Table View for Survey Results in an Angular Application

This step-by-step tutorial will help you set up a Table View for survey results using SurveyJS Dashboard in an Angular application. To add the Table View to your application, follow the steps below:

As a result, you will create the following view:

View Live Example

View Full Code on GitHub

If you are looking for a quick-start application that includes all SurveyJS components, refer to the following GitHub repository: SurveyJS + Angular CLI Quickstart Template.

Install the survey-analytics npm Package

SurveyJS Dashboard is distributed as a survey-analytics npm package. Run the following command to install it:

npm install survey-analytics

The Table View for SurveyJS Dashboard depends on the Tabulator library. The command above automatically installs it as a dependency.

Configure Styles

Add Themes

Open the angular.json file and reference the Tabulator and Table View style sheets:

{
  "$schema": "./node_modules/@angular/cli/lib/config/schema.json",
  // ...
  "projects": {
    "project-name": {
      "projectType": "application",
      // ...
      "architect": {
        "build": {
          // ...
          "options": {
            // ...
            "styles": [
              "src/styles.css",
              "node_modules/tabulator-tables/dist/css/tabulator.css",
              "node_modules/survey-analytics/survey.analytics.tabulator.css"
            ],
            // ...
          }
        }
      }
    }
  }
}

Add Fonts

Starting with SurveyJS v3.0.4, fonts are no longer included in SurveyJS packages. Load Open Sans separately to preserve the default appearance, unless your application already does so. If you use a custom font, load it instead. Otherwise, the browser uses a fallback font, which may affect spacing and layout.

To add Open Sans using Fontsource, run the following command:

npm install @fontsource/open-sans

The configuration below includes the font style sheets for weights 400, 600, and 700. Add them once to your application's global styles.

NgModule-based components
// angular.json
{
  "$schema": "./node_modules/@angular/cli/lib/config/schema.json",
  // ...
  "projects": {
    "project-name": {
      "projectType": "application",
      // ...
      "architect": {
        "build": {
          // ...
          "options": {
            // ...
            "styles": [
              "src/styles.css",
              "node_modules/@fontsource/open-sans/400.css",
              "node_modules/@fontsource/open-sans/600.css",
              "node_modules/@fontsource/open-sans/700.css",
              "node_modules/tabulator-tables/dist/css/tabulator.css",
              "node_modules/survey-analytics/survey.analytics.tabulator.css"
            ],
            // ...
          }
        }
      }
    }
  }
}
Standalone components
// app.component.ts
import "@fontsource/open-sans/400.css";
import "@fontsource/open-sans/600.css";
import "@fontsource/open-sans/700.css";
import "tabulator-tables/dist/css/tabulator.css";
import "survey-analytics/survey.analytics.tabulator.css";

Load Survey Results

When a respondent completes a survey, a JSON object with their answers is passed to the SurveyModel's onComplete event handler. You should send this object to your server and store it with a specific survey ID (see Handle Survey Completion). A collection of such JSON objects is a data source for the Table View. This collection can be processed (sorted, filtered, paginated) on the server or on the client.

Server-Side Data Processing

Server-side data processing enables the Table View to load survey results in small batches on demand and delegate sorting and filtering to the server. For this feature to work, the server must support these data operations. Refer to the following demo example on GitHub for information on how to configure the server and the client for this usage scenario:

SurveyJS Dashboard: Server-Side Data Processing Demo Example

Client-Side Data Processing

When data is processed on the client, the Table View loads the entire dataset at startup and applies sorting and filtering in a user's browser. This demands faster web connection and higher computing power but works smoother with small datasets.

To load survey results to the client, send the survey ID to your server and return an array of JSON objects with survey results:

import { AfterViewInit, Component } from '@angular/core';

const SURVEY_ID = 1;

@Component({
  // ...
})
export class AppComponent implements AfterViewInit {
  // ...
  ngAfterViewInit(): void {
    loadSurveyResults("https://your-web-service.com/" + SURVEY_ID)
      .then((surveyResults) => {
        // ...
        // Configure and render the Table View here
        // Refer to the section below
        // ...
      });
  }
}

function loadSurveyResults (url) {
  return new Promise((resolve, reject) => {
    const request = new XMLHttpRequest();
    request.open('GET', url);
    request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    request.onload = () => {
      const response = request.response ? JSON.parse(request.response) : [];
      resolve(response);
    }
    request.onerror = () => {
      reject(request.statusText);
    }
    request.send();
  });
}

For demonstration purposes, this tutorial uses auto-generated survey results. The following code shows a survey model and a function that generates the survey results array:

const surveyJson = {
  elements: [{
    name: "satisfaction-score",
    title: "How would you describe your experience with our product?",
    type: "radiogroup",
    choices: [
      { value: 5, text: "Fully satisfying" },
      { value: 4, text: "Generally satisfying" },
      { value: 3, text: "Neutral" },
      { value: 2, text: "Rather unsatisfying" },
      { value: 1, text: "Not satisfying at all" }
    ],
    isRequired: true
  }, {
    name: "nps-score",
    title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
    type: "rating",
    rateMin: 0,
    rateMax: 10,
  }],
  completedHtml: "Thank you for your feedback!",
};

function randomIntFromInterval(min: number, max: number): number {
  return Math.floor(Math.random() * (max - min + 1) + min);
}
function generateData() {
  const data = [];
  for (let index = 0; index < 100; index++) {
    const satisfactionScore = randomIntFromInterval(1, 5);
    const npsScore = satisfactionScore > 3 ? randomIntFromInterval(7, 10) : randomIntFromInterval(1, 6);
    data.push({
      "satisfaction-score": satisfactionScore,
      "nps-score": npsScore
    });
  }
  return data;
}

Render the Table

The Table View is rendered by the Tabulator component. Import this component and pass the survey model and results to its constructor to instantiate it. Assign the produced instance to a constant that will be used later to render the component:

import { AfterViewInit, Component } from '@angular/core';
import { Model } from 'survey-core';
import { Tabulator } from 'survey-analytics/survey.analytics.tabulator';

const surveyJson = { /* ... */ };
function generateData() { /* ... */ }

@Component({
  // ...
})
export class AppComponent implements AfterViewInit {
  ngAfterViewInit(): void {
    const survey = new Model(surveyJson);
    const surveyDataTable = new Tabulator(
      survey,
      generateData()
    );
  }
}

Switch to the component template and add a page element that will serve as the Table View container:

<!-- app.component.html -->
<div id="surveyDataTable"></div>

To render the Table View in the page element, call the render(containerId) method on the Tabulator instance you created previously:

// ...
@Component({
  // ...
})
export class AppComponent implements AfterViewInit {
  ngAfterViewInit(): void {
    // ...
    surveyDataTable.render("surveyDataTable");
  }
}
View Full Code
<div id="surveyDataTable"></div>
import { AfterViewInit, Component } from '@angular/core';
import { Model } from 'survey-core';
import { Tabulator } from 'survey-analytics/survey.analytics.tabulator';

const surveyJson = {
  elements: [{
    name: "satisfaction-score",
    title: "How would you describe your experience with our product?",
    type: "radiogroup",
    choices: [
      { value: 5, text: "Fully satisfying" },
      { value: 4, text: "Generally satisfying" },
      { value: 3, text: "Neutral" },
      { value: 2, text: "Rather unsatisfying" },
      { value: 1, text: "Not satisfying at all" }
    ],
    isRequired: true
  }, {
    name: "nps-score",
    title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
    type: "rating",
    rateMin: 0,
    rateMax: 10,
  }],
  completedHtml: "Thank you for your feedback!",
};

function randomIntFromInterval(min: number, max: number): number {
  return Math.floor(Math.random() * (max - min + 1) + min);
}
function generateData() {
  const data = [];
  for (let index = 0; index < 100; index++) {
    const satisfactionScore = randomIntFromInterval(1, 5);
    const npsScore = satisfactionScore > 3 ? randomIntFromInterval(7, 10) : randomIntFromInterval(1, 6);
    data.push({
      "satisfaction-score": satisfactionScore,
      "nps-score": npsScore
    });
  }
  return data;
}

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements AfterViewInit {
  ngAfterViewInit(): void {
    const survey = new Model(surveyJson);
    const surveyDataTable = new Tabulator(
      survey,
      generateData()
    );
    surveyDataTable.render("surveyDataTable");
  }
}

Activate a SurveyJS License

SurveyJS Dashboard is not available for free commercial use. To integrate it into your application, you must purchase a commercial license for the software developer(s) who will be working with the Dashboard APIs and implementing the integration. If you use SurveyJS Dashboard without a license, an alert banner will appear at the top of the Table View interface:

SurveyJS Table View: Alert banner

After purchasing a license, follow the steps below to activate it and remove the alert banner:

  1. Log in to the SurveyJS website using your email address and password. If you've forgotten your password, request a reset and check your inbox for the reset link.
  2. Open the following page: How to Remove the Alert Banner. You can also access it by clicking Set up your license key in the alert banner itself.
  3. Follow the instructions on that page.

Once you've completed the setup correctly, the alert banner will no longer appear.

Enable Export to PDF and Excel

The Table View for SurveyJS Dashboard allows users to save survey results as CSV, PDF, and XLSX documents. Export to CSV is supported out of the box. For export to PDF and XLSX, Table View needs the following third-party libraries:

Run the following commands to install them:

npm i jspdf
npm i jspdf-autotable
npm i xlsx

Review the third-party components' licenses to ensure that your project complies with the terms and conditions.

To enable export to PDF and Excel, import a jsPDF instance and apply the jsPDF-AutoTable plugin to it, then import SheetJS, and pass both the jsPDF and SheetJS instances to the Tabulator constructor:

// ... 
import jsPDF from "jspdf";
import { applyPlugin } from "jspdf-autotable";
applyPlugin(jsPDF);

import * as XLSX from "xlsx";

const surveyJson = { /* ... */ };
function generateData() { /* ... */ }

@Component({
  // ...
})
export class AppComponent implements AfterViewInit {
  ngAfterViewInit(): void {
    const survey = new Model(surveyJson);
    const surveyDataTable = new Tabulator(
      survey,
      generateData(),
      { jspdf: jsPDF, xlsx: XLSX }
    );
  }
}

With server-side data processing, exported documents contain only currently loaded data records. To export full datasets, you need to generate the documents on the server.

To view the application, run ng serve in a command line and open http://localhost:4200/ in your browser. If you do everything correctly, you should see the following result:

SurveyJS Table View: Export survey data to PDF, XLSX, and CSV

View Full Code on GitHub

See Also

Table View Demo Example

Send feedback to the SurveyJS team

Need help? Visit our support page

Export Survey Results to PDF or Excel | Self-Hosted JS Form Builder for Angular

Convert your survey data to manageable table format for easy filtering and analysis. Save survey results as PDF or Excel files to visualize or share with others. View free demo for Angular with a step-by-step setup guide.

Your cookie settings

We use cookies to make your browsing experience more convenient and personal. Some cookies are essential, while others help us analyse traffic. Your personal data and cookies may be used for ad personalization. By clicking “Accept All”, you consent to the use of all cookies as described in our Terms of Use and Privacy Statement. You can manage your preferences in “Cookie settings.”

Your renewal subscription expires soon.

Since the license is perpetual, you will still have permanent access to the product versions released within the first 12 month of the original purchase date.

If you wish to continue receiving technical support from our Help Desk specialists and maintain access to the latest product updates, make sure to renew your subscription by clicking the "Renew" button below.

Your renewal subscription has expired.

Since the license is perpetual, you will still have permanent access to the product versions released within the first 12 month of the original purchase date.

If you wish to continue receiving technical support from our Help Desk specialists and maintain access to the latest product updates, make sure to renew your subscription by clicking the "Renew" button below.

Table View for Survey Results in a Vue.js Application

This step-by-step tutorial will help you set up a Table View for survey results using SurveyJS Dashboard in a Vue.js application. To add the Table View to your application, follow the steps below:

As a result, you will create the following view:

View Live Example

View Full Code on GitHub

If you are looking for a quick-start application that includes all SurveyJS components, refer to the following GitHub repositories:

Install the survey-analytics npm Package

SurveyJS Dashboard is distributed as a survey-analytics npm package. Run the following command to install it:

npm install survey-analytics

The Table View for SurveyJS Dashboard depends on the Tabulator library. The command above automatically installs it as a dependency.

Configure Styles

Add Themes

Import the Tabulator and Table View style sheets in the component that will render the Table View:

<script setup lang="ts">
import 'tabulator-tables/dist/css/tabulator.css';
import 'survey-analytics/survey.analytics.tabulator.css';
</script>

<template>
  <!-- ... -->
</template>

Add Fonts

Starting with SurveyJS v3.0.4, fonts are no longer included in SurveyJS packages. Load Open Sans separately to preserve the default appearance, unless your application already does so. If you use a custom font, load it instead. Otherwise, the browser uses a fallback font, which may affect spacing and layout.

To add Open Sans using Fontsource, run the following command:

npm install @fontsource/open-sans

The following example imports font weights 400, 600, and 700 alongside the component style sheets. You can also place the font imports in your application's entry file or root layout to load them once for all SurveyJS components.

<script setup lang="ts">
import '@fontsource/open-sans/400.css';
import '@fontsource/open-sans/600.css';
import '@fontsource/open-sans/700.css';
import 'tabulator-tables/dist/css/tabulator.css';
import 'survey-analytics/survey.analytics.tabulator.css';
</script>

<template>
  <!-- ... -->
</template>

Load Survey Results

When a respondent completes a survey, a JSON object with their answers is passed to the SurveyModel's onComplete event handler. You should send this object to your server and store it with a specific survey ID (see Handle Survey Completion). A collection of such JSON objects is a data source for the Table View. This collection can be processed (sorted, filtered, paginated) on the server or on the client.

Server-Side Data Processing

Server-side data processing enables the Table View to load survey results in small batches on demand and delegate sorting and filtering to the server. For this feature to work, the server must support these data operations. Refer to the following demo example on GitHub for information on how to configure the server and the client for this usage scenario:

SurveyJS Dashboard: Server-Side Data Processing Demo Example

Client-Side Data Processing

When data is processed on the client, the Table View loads the entire dataset at startup and applies sorting and filtering in a user's browser. This demands faster web connection and higher computing power but works smoother with small datasets.

To load survey results to the client, send the survey ID to your server and return an array of JSON objects with survey results:

<script setup lang="ts">
// ...
import { onMounted } from "vue"

const SURVEY_ID = 1;

function loadSurveyResults (url) {
  return new Promise((resolve, reject) => {
    const request = new XMLHttpRequest();
    request.open('GET', url);
    request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    request.onload = () => {
      const response = request.response ? JSON.parse(request.response) : [];
      resolve(response);
    }
    request.onerror = () => {
      reject(request.statusText);
    }
    request.send();
  });
}

onMounted(() => {
  loadSurveyResults("https://your-web-service.com/" + SURVEY_ID)
    .then((surveyResults) => {
      // ...
      // Configure and render the Table View here
      // Refer to the section below
      // ...
    });
});
</script>

For demonstration purposes, this tutorial uses predefined survey results. The following code shows a survey model and the structure of the survey results array:

const surveyJson = {
  elements: [{
    name: "satisfaction-score",
    title: "How would you describe your experience with our product?",
    type: "radiogroup",
    choices: [
      { value: 5, text: "Fully satisfying" },
      { value: 4, text: "Generally satisfying" },
      { value: 3, text: "Neutral" },
      { value: 2, text: "Rather unsatisfying" },
      { value: 1, text: "Not satisfying at all" }
    ],
    isRequired: true
  }, {
    name: "nps-score",
    title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
    type: "rating",
    rateMin: 0,
    rateMax: 10,
  }],
  completedHtml: "Thank you for your feedback!",
};

function randomIntFromInterval(min: number, max: number): number {
  return Math.floor(Math.random() * (max - min + 1) + min);
}
function generateData() {
  const data = [];
  for (let index = 0; index < 100; index++) {
    const satisfactionScore = randomIntFromInterval(1, 5);
    const npsScore = satisfactionScore > 3 ? randomIntFromInterval(7, 10) : randomIntFromInterval(1, 6);
    data.push({
      "satisfaction-score": satisfactionScore,
      "nps-score": npsScore
    });
  }
  return data;
}

Render the Table

The Table View is rendered by the Tabulator component. Import this component and pass the survey model and results to its constructor to instantiate it. Assign the produced instance to a constant that will be used later to render the component:

<script setup lang="ts">
// ...
// Stylesheets are imported here
// ...
import { Model } from 'survey-core';
import { Tabulator } from 'survey-analytics/survey.analytics.tabulator';

const surveyJson = { /* ... */ };
function generateData() { /* ... */ }

onMounted(() => {
  const survey = new Model(surveyJson);
  const surveyDataTable = new Tabulator(
    survey,
    generateData()
  );
});
</script>

Switch to the component template and add a page element that will serve as the Table View container. To render the Table View in the page element, call the render(containerId) method on the Tabulator instance you created previously:

<script setup lang="ts">
// ...
onMounted(() => {
  // ...
  surveyDataTable.render("surveyDataTable");
});
</script>

<template>
  <div id="surveyDataTable" />
</template>
View Full Code
<script setup lang="ts">
import '@fontsource/open-sans/400.css';
import '@fontsource/open-sans/600.css';
import '@fontsource/open-sans/700.css';
import 'tabulator-tables/dist/css/tabulator.css';
import 'survey-analytics/survey.analytics.tabulator.css';
import { Model } from 'survey-core'
import { Tabulator } from 'survey-analytics/survey.analytics.tabulator'
import { onMounted } from "vue"

const surveyJson = {
  elements: [{
    name: "satisfaction-score",
    title: "How would you describe your experience with our product?",
    type: "radiogroup",
    choices: [
      { value: 5, text: "Fully satisfying" },
      { value: 4, text: "Generally satisfying" },
      { value: 3, text: "Neutral" },
      { value: 2, text: "Rather unsatisfying" },
      { value: 1, text: "Not satisfying at all" }
    ],
    isRequired: true
  }, {
    name: "nps-score",
    title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
    type: "rating",
    rateMin: 0,
    rateMax: 10,
  }],
  completedHtml: "Thank you for your feedback!",
};

function randomIntFromInterval(min: number, max: number) {
  return Math.floor(Math.random() * (max - min + 1) + min);
}
function generateData() {
  const data = [];
  for (let index = 0; index < 100; index++) {
    const satisfactionScore = randomIntFromInterval(1, 5);
    const npsScore = satisfactionScore > 3 ? randomIntFromInterval(7, 10) : randomIntFromInterval(1, 6);
    data.push({
      "satisfaction-score": satisfactionScore,
      "nps-score": npsScore
    });
  }
  return data;
}

onMounted(() => {
  const survey = new Model(surveyJson);
  const surveyDataTable = new Tabulator(
    survey,
    generateData()
  );
  surveyDataTable.render("surveyDataTable");
});
</script>

<template>
  <div id="surveyDataTable" />
</template>

</script>

Activate a SurveyJS License

SurveyJS Dashboard is not available for free commercial use. To integrate it into your application, you must purchase a commercial license for the software developer(s) who will be working with the Dashboard APIs and implementing the integration. If you use SurveyJS Dashboard without a license, an alert banner will appear at the top of the Table View interface:

SurveyJS Table View: Alert banner

After purchasing a license, follow the steps below to activate it and remove the alert banner:

  1. Log in to the SurveyJS website using your email address and password. If you've forgotten your password, request a reset and check your inbox for the reset link.
  2. Open the following page: How to Remove the Alert Banner. You can also access it by clicking Set up your license key in the alert banner itself.
  3. Follow the instructions on that page.

Once you've completed the setup correctly, the alert banner will no longer appear.

Enable Export to PDF and Excel

The Table View for SurveyJS Dashboard allows users to save survey results as CSV, PDF, and XLSX documents. Export to CSV is supported out of the box. For export to PDF and XLSX, Table View needs the following third-party libraries:

Run the following commands to install them:

npm i jspdf
npm i jspdf-autotable
npm i xlsx

Review the third-party components' licenses to ensure that your project complies with the terms and conditions.

To enable export to PDF and Excel, import a jsPDF instance and apply the jsPDF-AutoTable plugin to it, then import SheetJS, and pass both the jsPDF and SheetJS instances to the Tabulator constructor:

<script setup lang="ts">
// ...
import jsPDF from "jspdf";
import { applyPlugin } from "jspdf-autotable";
applyPlugin(jsPDF);

import * as XLSX from "xlsx";

const surveyJson = { /* ... */ };
function generateData() { /* ... */ }

onMounted(() => {
  const survey = new Model(surveyJson);
  const surveyDataTable = new Tabulator(
    survey,
    generateData(),
    { jspdf: jsPDF, xlsx: XLSX }
  );
  surveyDataTable.render("surveyDataTable");
});
</script>

With server-side data processing, exported documents contain only currently loaded data records. To export full datasets, you need to generate the documents on the server.

To view the application, run npm run dev in a command line and open http://localhost:5173/ in your browser. If you do everything correctly, you should see the following result:

SurveyJS Table View: Export survey data to PDF, XLSX, and CSV

View Full Code on GitHub

See Also

Table View Demo Example

Send feedback to the SurveyJS team

Need help? Visit our support page

Export Survey Results to PDF or Excel | Self-Hosted JS Form Builder for Vue.js

Convert your survey data to manageable table format for easy filtering and analysis. Save survey results as PDF or Excel files to visualize or share with others. View free demo for Vue.js with a step-by-step setup guide.

Your cookie settings

We use cookies to make your browsing experience more convenient and personal. Some cookies are essential, while others help us analyse traffic. Your personal data and cookies may be used for ad personalization. By clicking “Accept All”, you consent to the use of all cookies as described in our Terms of Use and Privacy Statement. You can manage your preferences in “Cookie settings.”

Your renewal subscription expires soon.

Since the license is perpetual, you will still have permanent access to the product versions released within the first 12 month of the original purchase date.

If you wish to continue receiving technical support from our Help Desk specialists and maintain access to the latest product updates, make sure to renew your subscription by clicking the "Renew" button below.

Your renewal subscription has expired.

Since the license is perpetual, you will still have permanent access to the product versions released within the first 12 month of the original purchase date.

If you wish to continue receiving technical support from our Help Desk specialists and maintain access to the latest product updates, make sure to renew your subscription by clicking the "Renew" button below.

Table View for Survey Results in a React Application

This step-by-step tutorial will help you set up a Table View for survey results using SurveyJS Dashboard in a React application. To add the Table View to your application, follow the steps below:

As a result, you will create the following view:

View Live Example

View Full Code on GitHub

If you are looking for a quick-start application that includes all SurveyJS components, refer to the following GitHub repositories:

Install the survey-analytics npm Package

SurveyJS Dashboard is distributed as a survey-analytics npm package. Run the following command to install it:

npm install survey-analytics

The Table View for SurveyJS Dashboard depends on the Tabulator library. The command above automatically installs it as a dependency.

Configure Styles

Add Themes

Create a React component that will render your table and import the Tabulator and Table View style sheets as shown below:

// components/Tabulator.tsx
import 'tabulator-tables/dist/css/tabulator.css';
import 'survey-analytics/survey.analytics.tabulator.css';

Add Fonts

Starting with SurveyJS v3.0.4, fonts are no longer included in SurveyJS packages. Load Open Sans separately to preserve the default appearance, unless your application already does so. If you use a custom font, load it instead. Otherwise, the browser uses a fallback font, which may affect spacing and layout.

To add Open Sans using Fontsource, run the following command:

npm install @fontsource/open-sans

The following example imports font weights 400, 600, and 700 alongside the component style sheets. You can also place the font imports in your application's entry file or root layout to load them once for all SurveyJS components.

// components/Tabulator.tsx
import '@fontsource/open-sans/400.css';
import '@fontsource/open-sans/600.css';
import '@fontsource/open-sans/700.css';
import 'tabulator-tables/dist/css/tabulator.css';
import 'survey-analytics/survey.analytics.tabulator.css';

Load Survey Results

When a respondent completes a survey, a JSON object with their answers is passed to the SurveyModel's onComplete event handler. You should send this object to your server and store it with a specific survey ID (see Handle Survey Completion). A collection of such JSON objects is a data source for the Table View. This collection can be processed (sorted, filtered, paginated) on the server or on the client.

Server-Side Data Processing

Server-side data processing enables the Table View to load survey results in small batches on demand and delegate sorting and filtering to the server. For this feature to work, the server must support these data operations. Refer to the following demo example on GitHub for information on how to configure the server and the client for this usage scenario:

SurveyJS Dashboard: Server-Side Data Processing Demo Example

Client-Side Data Processing

When data is processed on the client, the Table View loads the entire dataset at startup and applies sorting and filtering in a user's browser. This demands faster web connection and higher computing power but works smoother with small datasets.

To load survey results to the client, send the survey ID to your server and return an array of JSON objects with survey results:

// components/Tabulator.tsx
// ...
import { useState } from 'react';

const SURVEY_ID = 1;

export default function TableViewComponent() {
  const [surveyDataTable, setSurveyDataTable] = useState<Tabulator>();

  if (!surveyDataTable) {
    loadSurveyResults("https://your-web-service.com/" + SURVEY_ID)
      .then((surveyResults: any) => {
        // ...
        // Configure the Table View here
        // Refer to the sections below
        // ...
      });
  }

  return "...";
}

function loadSurveyResults (url: string) {
  return new Promise((resolve, reject) => {
    const request = new XMLHttpRequest();
    request.open('GET', url);
    request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    request.onload = () => {
      const response = request.response ? JSON.parse(request.response) : [];
      resolve(response);
    }
    request.onerror = () => {
      reject(request.statusText);
    }
    request.send();
  });
}

For demonstration purposes, this tutorial uses auto-generated survey results. The following code shows a survey model and a function that generates the survey results array:

// components/Tabulator.tsx
// ...
const surveyJson = {
  elements: [{
    name: "satisfaction-score",
    title: "How would you describe your experience with our product?",
    type: "radiogroup",
    choices: [
      { value: 5, text: "Fully satisfying" },
      { value: 4, text: "Generally satisfying" },
      { value: 3, text: "Neutral" },
      { value: 2, text: "Rather unsatisfying" },
      { value: 1, text: "Not satisfying at all" }
    ],
    isRequired: true
  }, {
    name: "nps-score",
    title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
    type: "rating",
    rateMin: 0,
    rateMax: 10,
  }],
  completedHtml: "Thank you for your feedback!",
};

function randomIntFromInterval(min: number, max: number): number  {
  return Math.floor(Math.random() * (max - min + 1) + min);
}

interface INpsDataObject {
  "satisfaction-score": number;
  "nps-score": number;
}

function generateData(): Array<INpsDataObject> {
  const data: Array<INpsDataObject> = [];
  for (let index = 0; index < 100; index++) {
    const satisfactionScore = randomIntFromInterval(1, 5);
    const npsScore = satisfactionScore > 3 ? randomIntFromInterval(7, 10) : randomIntFromInterval(1, 6);
    data.push({
      "satisfaction-score": satisfactionScore,
      "nps-score": npsScore
    });
  }
  return data;
}

Render the Table

The Table View is rendered by the Tabulator component. Import this component and pass the survey model and results to its constructor to instantiate it. Save the produced instance in a state variable that will be used later to render the component:

// components/Tabulator.tsx
// ...
import { useState } from 'react';
import { Model } from 'survey-core';
import { Tabulator } from 'survey-analytics/survey.analytics.tabulator';

const surveyJson = { /* ... */ }
interface INpsDataObject { /* ... */ }
function generateData(): Array<INpsDataObject> { /* ... */ }

export default function TableViewComponent() {
  const [survey, setSurvey] = useState<Model>();
  const [surveyDataTable, setSurveyDataTable] = useState<Tabulator>();
  const [surveyResults, setSurveyResults] = useState<Array<INpsDataObject>>(generateData());

  if (!survey) {
    const survey = new Model(surveyJson);
    setSurvey(survey);
  }

  if (!surveyResults) {
    setSurveyResults(generateData());
  }

  if (!surveyDataTable && !!survey) {
    const surveyDataTable = new Tabulator(
      survey,
      surveyResults
    );
    setSurveyDataTable(surveyDataTable);
  }

  return "...";
}

The Table View should be rendered in a page element. Add this element to the component markup. To render the Table View in the page element, call the render(containerId) method on the Tabulator instance you created previously, as shown below.

SurveyJS components are client-side components. Explicitly mark the React component that renders a SurveyJS component as client code using the 'use client' directive.

// components/Tabulator.tsx
'use client'
// ...
import { useEffect } from 'react';

export default function TableViewComponent() {
  // ...

  useEffect(() => {
    surveyDataTable?.render("surveyDataTable");
    return () => {
      document.getElementById("surveyDataTable")!.innerHTML = "";
    }
  }, [surveyDataTable]);

  return (
    <div id="surveyDataTable" />
  );
}

The lack of SSR support may cause hydration errors if a SurveyJS component is pre-rendered on the server. To ensure against those errors, use dynamic imports with ssr: false for React components that render SurveyJS components. The following code shows how to do this in Next.js:

// tabulator/page.tsx
import dynamic from "next/dynamic";

const TableView = dynamic(() => import('@/components/Tabulator'), {
  ssr: false,
})

export default function SurveyTabulator() {
  return (
    <TableView />
  );
}
View Full Code
// components/Tabulator.tsx
'use client'

import '@fontsource/open-sans/400.css';
import '@fontsource/open-sans/600.css';
import '@fontsource/open-sans/700.css';
import 'tabulator-tables/dist/css/tabulator.css';
import 'survey-analytics/survey.analytics.tabulator.css';
import { useState, useEffect } from 'react';
import { Model } from 'survey-core';
import { Tabulator } from 'survey-analytics/survey.analytics.tabulator';

const surveyJson = {
  elements: [{
    name: "satisfaction-score",
    title: "How would you describe your experience with our product?",
    type: "radiogroup",
    choices: [
      { value: 5, text: "Fully satisfying" },
      { value: 4, text: "Generally satisfying" },
      { value: 3, text: "Neutral" },
      { value: 2, text: "Rather unsatisfying" },
      { value: 1, text: "Not satisfying at all" }
    ],
    isRequired: true
  }, {
    name: "nps-score",
    title: "On a scale of zero to ten, how likely are you to recommend our product to a friend or colleague?",
    type: "rating",
    rateMin: 0,
    rateMax: 10,
  }],
  completedHtml: "Thank you for your feedback!",
};

function randomIntFromInterval(min: number, max: number): number  {
  return Math.floor(Math.random() * (max - min + 1) + min);
}

interface INpsDataObject {
  "satisfaction-score": number;
  "nps-score": number;
}

function generateData(): Array<INpsDataObject> {
  const data: Array<INpsDataObject> = [];
  for (let index = 0; index < 100; index++) {
    const satisfactionScore = randomIntFromInterval(1, 5);
    const npsScore = satisfactionScore > 3 ? randomIntFromInterval(7, 10) : randomIntFromInterval(1, 6);
    data.push({
      "satisfaction-score": satisfactionScore,
      "nps-score": npsScore
    });
  }
  return data;
}

export default function TableViewComponent() {
  const [survey, setSurvey] = useState<Model>();
  const [surveyDataTable, setSurveyDataTable] = useState<Tabulator>();
  const [surveyResults, setSurveyResults] = useState<Array<INpsDataObject>>(generateData());
  if (!survey) {
    const survey = new Model(surveyJson);
    setSurvey(survey);
  }
  if (!surveyResults) {
    setSurveyResults(generateData());
  }

  if (!surveyDataTable && !!survey) {
    const surveyDataTable = new Tabulator(
      survey,
      surveyResults
    );
    setSurveyDataTable(surveyDataTable);
  }

  useEffect(() => {
    surveyDataTable?.render("surveyDataTable");
    return () => {
      document.getElementById("surveyDataTable")!.innerHTML = "";
    }
  }, [surveyDataTable]);

  return (
    <div id="surveyDataTable" />
  );
}
// tabulator/page.tsx
import dynamic from "next/dynamic";

const TableViewComponent = dynamic(() => import('@/components/Tabulator'), {
  ssr: false,
})

export default function TableView() {
  return (
    <TableViewComponent />
  );
}

Activate a SurveyJS License

SurveyJS Dashboard is not available for free commercial use. To integrate it into your application, you must purchase a commercial license for the software developer(s) who will be working with the Dashboard APIs and implementing the integration. If you use SurveyJS Dashboard without a license, an alert banner will appear at the top of the Table View interface:

SurveyJS Table View: Alert banner

After purchasing a license, follow the steps below to activate it and remove the alert banner:

  1. Log in to the SurveyJS website using your email address and password. If you've forgotten your password, request a reset and check your inbox for the reset link.
  2. Open the following page: How to Remove the Alert Banner. You can also access it by clicking Set up your license key in the alert banner itself.
  3. Follow the instructions on that page.

Once you've completed the setup correctly, the alert banner will no longer appear.

Enable Export to PDF and Excel

The Table View for SurveyJS Dashboard allows users to save survey results as CSV, PDF, and XLSX documents. Export to CSV is supported out of the box. For export to PDF and XLSX, Table View needs the following third-party libraries:

Run the following commands to install them:

npm i jspdf
npm i jspdf-autotable
npm i xlsx

Review the third-party components' licenses to ensure that your project complies with the terms and conditions.

To enable export to PDF and Excel, import a jsPDF instance and apply the jsPDF-AutoTable plugin to it, then import SheetJS, and pass both the jsPDF and SheetJS instances to the Tabulator constructor:

// components/Tabulator.tsx
// ...
import jsPDF from "jspdf";
import { applyPlugin } from "jspdf-autotable";
applyPlugin(jsPDF);
import * as XLSX from "xlsx";
// ...
export default function TableViewComponent() {
  // ...
  if (!surveyDataTable && !!survey) {
    const surveyDataTable = new Tabulator(
      survey,
      surveyResults,
      { jspdf: jsPDF, xlsx: XLSX }
    );
    setSurveyDataTable(surveyDataTable);
  }
  // ...
}

With server-side data processing, exported documents contain only currently loaded data records. To export full datasets, you need to generate the documents on the server.

To view the application, run npm run dev in a command line and open http://localhost:3000/ in your browser. If you do everything correctly, you should see the following result:

SurveyJS Table View: Export survey data to PDF, XLSX, and CSV

View Full Code on GitHub

See Also

Table View Demo Example

Send feedback to the SurveyJS team

Need help? Visit our support page

Export Survey Results to PDF or Excel | Self-Hosted JS Form Builder for React

Convert your survey data to manageable table format for easy filtering and analysis. Save survey results as PDF or Excel files to visualize or share with others. View free demo for React with a step-by-step setup guide.

Your cookie settings

We use cookies to make your browsing experience more convenient and personal. Some cookies are essential, while others help us analyse traffic. Your personal data and cookies may be used for ad personalization. By clicking “Accept All”, you consent to the use of all cookies as described in our Terms of Use and Privacy Statement. You can manage your preferences in “Cookie settings.”

Your renewal subscription expires soon.

Since the license is perpetual, you will still have permanent access to the product versions released within the first 12 month of the original purchase date.

If you wish to continue receiving technical support from our Help Desk specialists and maintain access to the latest product updates, make sure to renew your subscription by clicking the "Renew" button below.

Your renewal subscription has expired.

Since the license is perpetual, you will still have permanent access to the product versions released within the first 12 month of the original purchase date.

If you wish to continue receiving technical support from our Help Desk specialists and maintain access to the latest product updates, make sure to renew your subscription by clicking the "Renew" button below.